/*	xmms ao output plugin
 *	Copyright (C) 2003 Levi Ramsey
 *
 *	This program is Free Software and licensed under the GNU GPL
 *
 *	Description: Outputs audio from xmms to libao2.  This enables automatic
 *		detection of sound system to use (OSS, ALSA, esd, aRts, etc.)
 *
 *	Based on Galex Yen's esd output plugin
 *
 *	Contains code (C) 1998-1999 Mikael Alm, Olle Hallnas, Thomas Nilsson,
 *		and 4Front Technologies
 */

#include "aoout.h"
#include <xmms/configfile.h>

aoout_cfg ao_cfg;

void aoout_init(void) {
	ConfigFile *cfgfile;

	memset(&ao_cfg, 0, sizeof(aoout_cfg));
	ao_cfg.buffering=TRUE;
	ao_cfg.bufsize=3000;
	ao_cfg.bufchunk=1000;
	ao_cfg.fileout=FALSE;
	ao_cfg.filetype="wav";
	ao_cfg.fileoverwrite=TRUE;
	ao_cfg.directory=".";
	ao_cfg.prevolume=TRUE;
	ao_cfg.effectfile=TRUE;
	ao_cfg.normalize=TRUE;
	ao_cfg.maxgain=10.0;
	ao_cfg.mingain=0.20;
	ao_cfg.lvol=50;
	ao_cfg.rvol=50;

	cfgfile=xmms_cfg_open_default_file();

	xmms_cfg_read_boolean(cfgfile, "aoout", "buffering", &ao_cfg.buffering);
	xmms_cfg_read_int(cfgfile, "aoout", "buffer_size", &ao_cfg.bufsize);
	xmms_cfg_read_int(cfgfile, "aoout", "buffer_chunk", &ao_cfg.bufchunk);
	xmms_cfg_read_boolean(cfgfile, "aoout", "file_output", &ao_cfg.fileout);
	xmms_cfg_read_string(cfgfile, "aoout", "file_type", &ao_cfg.filetype);
	xmms_cfg_read_boolean(cfgfile, "aoout", "file_overwrite", &ao_cfg.fileoverwrite);
	xmms_cfg_read_string(cfgfile, "aoout", "file_directory", &ao_cfg.directory);
	xmms_cfg_read_boolean(cfgfile, "aoout", "prevolume", &ao_cfg.prevolume);
	xmms_cfg_read_boolean(cfgfile, "aoout", "effectfile", &ao_cfg.effectfile);
	xmms_cfg_read_boolean(cfgfile, "aoout", "normalize", &ao_cfg.normalize);
	xmms_cfg_read_float(cfgfile, "aoout", "maxgain", &ao_cfg.maxgain);
	xmms_cfg_read_float(cfgfile, "aoout", "mingain", &ao_cfg.mingain);
	xmms_cfg_read_int(cfgfile, "aoout", "lvol", &ao_cfg.lvol);
	xmms_cfg_read_int(cfgfile, "aoout", "rvol", &ao_cfg.rvol);

	xmms_cfg_free(cfgfile);
}
